<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

/* Function:    RunWithParams
 * 
 * Description: Entry point for lets a user change his or her password
 *
 * Parameters:  methodName - the method to call
 *              params - the parameters sent to the script
 *
 * Returns:     Script response XML object
 *
 * Revision History:
 *
 *  2003-03-18 - Initial version (adam)
 *
 *
 */

function RunWithParams($methodName, $params)
{   
    global $_CONF;
    
    $response = array("template" => "changepassword.tpl");
    
    switch($methodName)
    {
        case "change":
            return VerifyPassword($params);
            break;
            
        default:
            break;
    
    }
    
    return ScriptResponse($response);
}


/* Function:    VerifyPassword
 * 
 * Description: Verifies the password before changing it. Passwords must be between 5 and 32 characters in length
 *
 * Parameters:  params - the parameters sent to the script
 *
 * Returns:     Script response XML object
 *
 * Revision History:
 *
 *  2003-03-18 - Initial version (adam)
 *
 *
 */

function VerifyPassword($params)
{
    global $_DATABASE;
    global $_CONF;
    
    $username = $_CONF["username"];
    
    $oldPassword = $params["oldpass"];
    $newPassword = $params["newpass"];
    $verifyPassword = $params["verifypass"];
    
    if(!$oldPassword) {
        return ScriptErrorResponse("", $params["locale"]["errOldPassword"]);
    }
    
        // Check to see if the old password matches with that stored in the database
    
    $row = $_DATABASE->Get_Row("soybo_users", "password", "username", $username);
    
    if(!$row)
        return ScriptErrorResponse("", $params["locale"]["errServer"]);
    
    $currPassword = $row["password"];
    
    if(md5($oldPassword) != $currPassword)
        return ScriptErrorResponse("", $params["locale"]["errIncorrectPassword"]);
    
    if(!$newPassword || !$verifyPassword)
        return ScriptErrorResponse("", $params["locale"]["errPassword"]);
    
    if($newPassword != $verifyPassword)
        return ScriptErrorResponse("", $params["locale"]["errPasswordMatch"]);  
    
    if(strlen($newPassword) < 5 || strlen($newPassword) > 32)
        return ScriptErrorResponse("", $params["locale"]["errPasswordLength"]);
    
        // Everything checks out, so we update the database with the new password
    
    $result = $_DATABASE->Update_Row("soybo_users", "password", md5($newPassword), "username", $username);
    
    $response = array("template" => "success.tpl");
    
    return ScriptResponse($response);
}


?>