<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

/* Function:    RunWithParams
 *
 * Description: Entry point for soyvice that clears out the media cache on the Soybo Server.
 *              The media folder holds information such as stylesheets, images, etc. for
 *              soyvices to be able to reference.
 *
 * Parameters:  methodName - the method to call
 *              params - list of parameters
 *
 * Returns:     Script response object
 *
 * Revision History:
 *
 *  2003-03-18 - Initial version (adam)
 *
 *
 */
 
function RunWithParams($methodName, $params)
{   
    $response = array("template" => "clearmedia.tpl");
    
    switch($methodName)
    {
        case "mustconfirm":
            $response["confirm"] = true;
            break;
        
        case "confirmed":
            global $_CONF;
            
                // We don't actually delete the cache files. We simply move the existing
                // media directory into the trash directory under the Soybo Data directory
            
            $mediaPath = $_CONF["path_html"] . "/media";
            
            if(file_exists($mediaPath)) {
            
                    // Create the media trash directory
            
                $trashPath = $_CONF["path"] . "/trash";
                
                if(!file_exists($trashPath)) {
                    $result = mkdir($trashPath, 0777);
                    if(!$result) ScriptErrorResponse("", $params["locale"]["errMkdir"]);
                    //chmod($trashPath, 0777);
                }
                
                    // Get a random folder name (i.e. time)
                
                $trashFolderName = date("Ymd_His", time()) . "_media";
                $trashFolderPath = $trashPath . "/" . $trashFolderName;
    
    			//echo "renaming: $mediaPath<br />";
    			//echo "to: $trashFolderPath<br />";
    			
                rename($mediaPath, $trashFolderPath);
                            
                $response["success"] = true;
                $response["trashDirectory"] = $trashFolderPath;
            } else {
                ScriptErrorResponse("", $params["locale"]["errNoMediaCache"]);
            }
            
            break;
            
        default:
            break;
    
    }

    return ScriptResponse($response);
}


?>