<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

/* Function:    RunWithParams
 *
 * Description: Entry point for soyvice manages all the HTTP User Agents that have accessed the
 *              system (aside from XML-RPC clients).
 *
 * Parameters:  methodName - the method to call
 *              params - list of parameters
 *
 * Returns:     Script response object
 *
 * Revision History:
 *
 *  2003-03-18 - Initial version (adam)
 *
 *
 */
 
function RunWithParams($methodName, $params)
{   
    global $_CLIENTS;
    global $_CONF;
    
        // Update the default client class in the soybo_preferences table
        
    if($methodName == "update_default_client") {
        $new_default_client = $params["new_default_client"];

        if($new_default_client && ($new_default_client != $_CONF["default_client_classname"])) {
            $query = "UPDATE soybo_preferences SET default_client_classname='$new_default_client' WHERE id='1' LIMIT 1";
            $result = mysql_query($query) or print(mysql_error());
            
            $_CONF["default_client_classname"] = $new_default_client;
            
            $response["template"] = "success_default_client.tpl";
            $response["clientname"] = $new_default_client;
            
            return ScriptResponse($response);
            
        } else {
            return ScriptErrorResponse("", $params["locale"]["errSameDefaultClient"]);
        }
    } else if($methodName == "update_selected") {
        
            // Update the selected clients to use the selected client name
        
        $classname = $params["new_client_classname"];
        $clients = $params["clients"];
        $num = count($clients);
        
        if($clients && $num > 0) {
            for($i = 0; $i < $num; $i++) {
                $client_id = $clients[$i];
            
                $query = "UPDATE soybo_clients SET clientname='$classname' WHERE client_id='$client_id'";
                $result = mysql_query($query) or die(mysql_error()); //die("An error occurred while updating the soybo_clients database");
            }
            
            if(!$classname) {
                $classname = $params["locale"]["labelDefaultClient"];
            }
            
            $response["template"] = "success_selected_clients.tpl";
            $response["clientname"] = $classname;
            
            return ScriptResponse($response);
            
        } else {
            return ScriptErrorResponse("", $params["locale"]["errNoClientsSelected"]);
        }
    } else {
        
            // Generate the data for the template
        
        $sort = ($params["sort"]) ? $params["sort"] : "useragent";
        
        // Retrieve the list of clients from the database
        
        $query = "SELECT * FROM soybo_clients";
        $result = mysql_query($query);
        
        if($result) {
            $clients = array();
            
            while($row = mysql_fetch_assoc($result)) {
                $clients[] = array("id" => $row["client_id"], "useragent" => $row["useragent"], "clientname" => $row["clientname"]);
            }
            
            $response["clients"] = $clients;
            
                // get the default client classname
                
            $response["default_clientname"] = $_CONF["default_client_classname"];
            
                // create the client info list
            
            foreach($_CLIENTS as $classname => $name) {
                $client_list[] = $classname;
            }
            
            $response["template"] = "clients.tpl";
            $response["useragent"] = $_SERVER["HTTP_USER_AGENT"];
            $response["client_list"] = $client_list;
            
            return ScriptResponse($response);               
        }
    }

    return ScriptErrorResponse("", $params["locale"]["errDatabase"]);
}


?>