<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   
   
/* Function:    RunWithParams
 *
 * Description: Entry point for soyvice displays and edits the soybo_preferences database table.
 *
 * Parameters:  methodName - the method to call
 *              params - list of parameters
 *
 * Returns:     Script response object
 *
 * Revision History:
 *
 *  2003-03-18 - Initial version (adam)
 *
 *
 */
 
function RunWithParams($methodName, $params)
{   
    if($methodName == "update")
        return UpdatePreferences($params);
    
    $response["preferences"] = RetrievePreferences();
    $response["template"] = "preferences.tpl";
    
    return ScriptResponse($response);
}



/* Function:    RetrievePreferences
 *
 * Description: Retrieves the preferences from the database to populate the template file
 *
 * Parameters:  None
 *
 * Returns:     array containing the preferences information
 *
 * Revision History:
 *
 *  2003-03-18 - Initial version (adam)
 *
 *
 */

function RetrievePreferences()
{
    $query = "SELECT * FROM soybo_preferences WHERE ID='1'";
    $result = mysql_query($query);
    $row = mysql_fetch_assoc($result);
    
        // Get a list of all the locales
    
    global $_LOCALIZATION;
    global $_CONF;
    
    $localeName = ($_CONF["localeName"]) ? $_CONF["localeName"] : $_CONF["default_locale_name"];            
    $locales = array();

    foreach($_LOCALIZATION as $locale => $localeArray) {
    	//echo_object(0, $localeArray, "Locale");
        $value = strtolower($locale);
        
        array_push($locales, array( "name" => $localeArray["display_name"],
                                    "selected" => ($value == $localeName) ? true : false,
                                    "value" => $value
                                ));
    }
    //echo_object(0, $locales, "Locales");
    $row["locales"] = $locales;

        // Get a list of all the base clients
        
    $clients = array();
    $defaultClient = $_CONF["default_client_classname"];
    
    array_push($clients, array("name" => "Desktop", "value" => "Desktop_Client", "selected" => ($defaultClient == "Desktop_Client") ? true : false));
    array_push($clients, array("name" => "Handheld", "value" => "Handheld_Client", "selected" => ($defaultClient == "Handheld_Client") ? true : false));
    array_push($clients, array("name" => "Phone", "value" => "Phone_Client", "selected" => ($defaultClient == "Phone_Client") ? true : false));
    array_push($clients, array("name" => "WAP", "value" => "WAP_Client", "selected" => ($defaultClient == "WAP_Client") ? true : false));
    
    $row["clients"] = $clients;
    
    return $row;
}



/* Function:    UpdatePreferences
 *
 * Description: Updates the preferences from the database
 *
 * Parameters:  params
 *
 * Returns:     Script response object
 *
 * Revision History:
 *
 *  2003-03-18 - Initial version (adam)
 *
 *
 */

function UpdatePreferences($params)
{
    $default_locale_name = strtolower($params["default_locale_name"]);
    $default_client_classname = $params["default_client_classname"];
    $session_expires_after = $params["session_expires_after"];
    $session_cleanup_delay = $params["session_cleanup_delay"];
    $allow_logging = $params["allow_logging"];
    $allow_guest_access = $params["allow_guest_access"];
    $allow_http_access = $params["allow_http_access"];
    $allow_xmlrpc_access = $params["allow_xmlrpc_access"];
    $allow_loopback_calls = $params["allow_loopback_calls"];
    
    //echo_object(0, $params, "Parameters");
        
    $query = "UPDATE soybo_preferences SET  default_locale_name='$default_locale_name', 
                                            default_client_classname='$default_client_classname',
                                            session_expires_after='$session_expires_after',
                                            session_cleanup_delay='$session_cleanup_delay',
                                            allow_logging='$allow_logging',
                                            allow_guest_access='$allow_guest_access',
                                            allow_http_access='$allow_http_access',
                                            allow_xmlrpc_access='$allow_xmlrpc_access',
                                            allow_loopback_calls='$allow_loopback_calls'
                                        WHERE id='1' LIMIT 1";
    $result = mysql_query($query);
    
    if(!$result) {
        echo mysql_error();
    }

        // If guest login has been turned off, we need to invalidate any guest sessions that might be
        // active at the moment
    
    if(!$allow_guest_access) {
        global $_DATABASE;
        
        $user_id = $_DATABASE->Get_User_ID("guest");
        $query = "DELETE FROM soybo_sessions WHERE user_id='$user_id'";
        $result = mysql_query($query);
        $response["disabled_guest_access"] = true;
        
        GFn_Log_Event(kLOG_SERVER, "Guest access disable. Closing all open guest sessions.");
    }

    GFn_Log_Event(kLOG_SERVER, "Server preferences updated.");

    
    $response["template"] = "success.tpl";
        
    return ScriptResponse($response);
}


?>