<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

function RunWithParams($methodName, $params)
{	
	$response = array("template" => "update_email.tpl");
	
	switch($methodName)
	{
		case "change":
			return UpdateEmail($params);
			break;
			
		default:
			global $_CONF;
			global $_DATABASE;
		
			$username = $_CONF["username"];
			$row = $_DATABASE->Get_Row("soybo_users", "email", "username", $username);
			
			if(!$row)
				return ScriptErrorResponse("", "An error occured while retrieving your user information from the database.");
			
			$currEmail = $row["email"];
			$response["current_email"] = $currEmail;

			break;
	
	}
	
	return ScriptResponse($response);
}


function UpdateEmail($params)
{
	global $_DATABASE;
	global $_CONF;
	
	$username = $_CONF["username"];
	
	$newEmail = $params["email"];
	$confirmEmail = $params["confirm_email"];
	
	if($newEmail != $confirmEmail)
		return ScriptErrorResponse("", "The email addresses you entered do not match. Please try again.");

	$row = $_DATABASE->Get_Row("soybo_users", "email", "username", $username);
	
	if(!$row)
		return ScriptErrorResponse("", "An error occured while retrieving your user information from the database.");
	
	$currEmail = $row["email"];
	
	if(strpos("@", $newEmail) !== false)
		return ScriptErrorResponse("", "Your email address is not properly formatted. Please try again.");	
	
		// Everything checks out, so we update the database with the new password
	
	$result = $_DATABASE->Update_Row("soybo_users", "email", $newEmail, "username", $username);
	
	$response = array("template" => "success.tpl");
	
	return ScriptResponse($response);
}


?>