<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   
   
include_once "install_functions.php";
include_once "install_configuration.php";
include_once "install_database.php";
include_once "install_administrator.php";

$cmd = $_REQUEST["cmd"];

global $_CONF;

switch($cmd)
{
	case "submit":
		$response = "";
		
		$err = Validate_Parameters();
		if($err) die("<p>$err</p>");
		
			// Create the configuration file

		Create_Configuration();
		
		$response .= "<p>Configuration file: OK</p>";
		
			// Connect to the database
	
		Connect_Database();
		
		
		$response .= "<p>Database Connection: OK</p>";
		
			// Install the database	
	
		$response .= Install_Database();
		
		$response .= "<p>Default Database Generated.</p>";
		
			// Create the Administrator
			
		$response .= Create_Administrator();
		
		$response .= "<p>Administrator Account Created.</p>";
		
			// Display the success page
		
		Display_Success_Page($response);
		
		break;
	
	default:
		Display_Page();
		break;
}



/* Function:			Validate_Parameters
 *
 * Description:			Funcction to validate the parameters that the user
 *						entered in the installation screen.
 *
 * Parameters:			none
 *
 * Revision History:	3/12/2003 - adam
 *
 */
 
function Validate_Parameters()
{
		// Check the parameters for the SQL Host and Database
		
	$sql_host = $_REQUEST["sql_host"];
	if(!$sql_host) return kErrSqlHost;
	
	$sql_database = $_REQUEST["sql_database"];
	if(!$sql_database) return kErrSqlDatabase;
   	
	$path = realpath($_REQUEST["path"]);
	$path_html = realpath($_REQUEST["path_html"]);
	$site_url = $_REQUEST["site_url"];
	
		// Verify the site url
	
	if(!$site_url) return kErrSiteURL;
	$parts = parse_url($site_url);
	$root = realpath($_SERVER["DOCUMENT_ROOT"] . $parts["path"]);

		// Check to see if the paths to the
		// Soybo WWW and Soybo Data directories exist
	
	if(!file_exists($path) || !is_dir($path)) return kErrSoyboDataDirectory;
	if(!file_exists($path_html) || !is_dir($path_html)) return kErrSoyboWWWDirectory;

//	if($root != $path_html) return kErrSiteURLPathHTML;

		// Check the admin account parameters
		
	$username = $_REQUEST["username"];
	$email = $_REQUEST["email"];
	$password = $_REQUEST["password"];
	$confirmPass = $_REQUEST["confirm_password"];	
	
		// Validate the username parameters
		
	if(!$username) return kErrInvalidUsername;
	if(strlen($username) > 32) return kErrInvalidUsername;
	if(strlen($username) < 3) return kErrInvalidUsername;
	if($username != ereg_replace("[^[:alnum:]_-]", "", $username)) return kErrInvalidUsername;
			
		// Verify the email address
	
	if(!$email) return kErrEmail;
	if(!eregi("^[0-9a-z_]([-_.]?[0-9a-z])*@[0-9a-z][-.0-9a-z]*\\.[a-z]{2,4}[.]?$", $email, $pieces))
		 return kErrEmail;
	
		// Verify the password
	
	if(!$password || !$confirmPass) return kErrNoPassword;
	if($password != $confirmPass) return kErrPasswordMatch;
	if(strlen($password) > 32) return kErrPasswordLength;
	if(strlen($password) < 5) return kErrPasswordLength;
	
		// All clear!
		
	return false;
}





/* Function:			Display_Page
 *
 * Description:			Function for displaying the database install page.
 *
 * Parameters:			none
 *
 * Revision History:	3/12/2003 - adam
 *
 */

function Display_Page()
{	
	echo <<<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
	<title>Soybo Server Installer</title>
	<link rel="stylesheet" href="stylesheets/default.css" />
</head>
<body>

<div id="header">
	<div>
		<a href="http://www.soybo.com/"><img src="images/soybo_header.gif" width="285" height="75" alt="Soybo" /></a>
	</div>
	<div id="navbar">
		Soybo Server Installer
	</div>
</div>

<div id="content">

<form method="post" action="install.php">

	<div>
	
		<h1 align="center">Server Environment</h1>
	
		<div style="text-align: justify; margin-right: 5%; margin-left: 5%; margin-bottom: 20px;">
			<p>
			Please enter the following information about your server environment. 
			Your Soybo WWW directory should be placed in a location accessible by your web server.
			</p>
			
			<p>
			<strong>NOTE: </strong>For security reasons, your Soybo Data directory
			<strong>should not</strong> be placed under your web server root. You should
			place it in your user home or another location on your computer.
			</p>
			
			<p>
			Do not add a trailing slash to either the Soybo WWW or Soybo Data fields.
			</p>
		</div>
			
		<table align="center" border="1" cellpadding="0" cellspacing="0">
			<tr>
				<th align="right">Path to Soybo Data:<br /><small>(absolute path)</small>&nbsp;</th>
				<td><input type="text" name="path" value="" size="40"  /></td>
			</tr>
			<tr>
				<th align="right">Path to Soybo WWW:<br /><small>(absolute path)</small>&nbsp;</th>
				<td><input type="text" name="path_html" value="" size="40"  /></td>
			</tr>
			<tr>
				<th align="right">Site URL:</th>
				<td><input type="text" name="site_url" value="" size="40" /></td>
			</tr>
			<tr>
				<th align="right">Site Email:<br /><small>(optional)</small>&nbsp;</th>
				<td><input type="text" name="site_email" value="" size="40" /></td>
			</tr>
		</table>
		
		<br />
		<hr />
		
		<h1 align="center">SQL Environment</h1>
		
		<div style="text-align: justify; margin-right: 5%; margin-left: 5%; margin-bottom: 20px;">
			<p>
			Please enter the following information about your SQL environment. If you do not choose
			to enter an existing database name, you must first create a database before proceeding.
			</p>
		</div>		
		
		<table align="center" border="1" cellpadding="0" cellspacing="0" width="75%">
			<tr>
				<th align="right">SQL Driver: </th>
				<td>mysql</td>
			</tr>
			<tr>
				<th align="right">SQL Host: </th>
				<td><input type="text" name="sql_host" value="localhost" size="40" /></td>
			</tr>
			<tr>
				<th align="right">SQL Database</th>
				<td><input type="text" name="sql_database" value="" size="40" /></td>
			</tr>
			<tr>
				<th align="right">SQL User: </th>
				<td><input type="text" name="sql_user" value="" size="40" /></td>
			</tr>
			<tr>
				<th align="right">SQL Password: </th>
				<td><input type="text" name="sql_password" value="" size="40" /></td>
			</tr>
			<tr>
				<th colspan="2" align="center">
				<input type="checkbox" name="drop" onclick="if(this.value) alert('Checking this box will delete any Soybo database tables that are currently installed!');"/> Drop existing Soybo tables
				</th>
			</tr>
		</table>
		
		<br />
		<hr />
		
		<h1 align="center">Administrator Account</h1>
	
		<div style="text-align: justify; margin-right: 5%; margin-left: 5%; margin-bottom: 20px;">
			<p>Please enter the following information to set up your administrator account.</p>
		</div>
			
		<table align="center" border="1" cellpadding="0" cellspacing="0">
			<tr>
				<th align="right">Username: </th>
				<td><input type="text" name="username" value="" size="40"  /></td>
			</tr>
			<tr>
				<th align="right">Password: </th>
				<td><input type="password" name="password" value="" size="40"  /></td>
			</tr>
			<tr>
				<th align="right">Confirm Your Password: </th>
				<td><input type="password" name="confirm_password" value="" size="40" /></td>
			</tr>
			<tr>
				<th align="right">Email:</th>
				<td><input type="text" name="email" value="" size="40" /></td>
			</tr>
		</table>
		
		<br />
		
		<p align="center">
			<input type="hidden" name="cmd" value="submit" />
			<input type="submit" value="Continue" />
		</p>
	</form>
	
	</div>
</div>

<div id="footer">
	<a href="http://www.soybo.com/"><img src="images/soybo_icon_small.gif" width="40" height="25" alt="Soybo" /></a><br /><br />
	Soybo Copyright &copy; 2003 <a href="http://www.tow.com/">Adam Tow</a> and <a href="http://www.soybo.com/">Soybo.com</a>. All rights reserved.
</div>

</body>
</html>
EOF;

}




/* Function:			Display_Success_Page
 *
 * Description:			Function for displaying the database install page.
 *
 * Parameters:			none
 *
 * Revision History:	3/12/2003 - adam
 *
 */

function Display_Success_Page($response)
{
	$site_url = $_REQUEST["site_url"];
	
	echo <<<EOF
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
	<title>Soybo Server Installer</title>
	<link rel="stylesheet" href="stylesheets/default.css" />
</head>
<body>

<div id="header">
	<div>
		<a href="http://www.soybo.com/"><img src="images/soybo_header.gif" width="285" height="75" alt="Soybo" /></a>
	</div>
	<div id="navbar">
		Soybo Server Installer
	</div>
</div>

<div id="content">

<h1>Installation Log</h1>

<div style="font-size: 10px;">
$response
</div>

<p>
<strong>Soybo Installation Complete!</strong>
</p>

<p>
You may now log in to your Soybo server using your administrator username and password.
</p>

<form method="post" action="$site_url">
<p align="center">
<input type="submit" value="Login" />
</p>
</form>

</div>

<div id="footer">
	<a href="http://www.soybo.com/"><img src="images/soybo_icon_small.gif" width="40" height="25" alt="Soybo" /></a><br /><br />
	Soybo Copyright &copy; 2003 <a href="http://www.tow.com/">Adam Tow</a> and <a href="http://www.soybo.com/">Soybo.com</a>. All rights reserved.
</div>

</body>
</html>
EOF;

}


?>