<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

/* Function:			Create_Configuration
 *
 * Description:			Creates the configuration file for the Soybo Server
 *
 * Parameters:
 *
 *	sql_host		- the MySQL Host
 *	sql_database	- the database name to use
 *	sql_user		- the MySQL username
 *	sql_password	- the password for the MySQL user
 *
 * Returns:		true or error
 *
 * Revision History:	3/12/2003 - adam
 *
 */
 
function Create_Configuration()
{	
	global $_CONF;
	
	$sql_host = $_REQUEST["sql_host"];
	$sql_database = $_REQUEST["sql_database"];
   	$sql_user = $_REQUEST["sql_user"];
   	$sql_password = $_REQUEST["sql_password"];
   	
	$path = $_REQUEST["path"];
	$path_html = $_REQUEST["path_html"];
	$site_url = $_REQUEST["site_url"];
	$site_email = $_REQUEST["site_email"];
	
	$confPath = $path_html . "/conf_global.php";
	
	$fp = @fopen($confPath, "w") or die("<p>An error occurred while creating the <b>conf_global.php</b> file. Please make sure permissions (777) have been set properly on the source directory.</p>");
	
	$str = "<?php\n\n";
	$str .= "global \$_CONF;\n\n";
	$str .= "\$_CONF[\"sql_driver\"]	= \"mysql\";\n";
	$str .= "\$_CONF[\"sql_host\"]      = \"$sql_host\";\n";
	$str .= "\$_CONF[\"sql_database\"]  = \"$sql_database\";\n";
	$str .= "\$_CONF[\"sql_user\"]      = \"$sql_user\";\n\n";
	$str .= "\$_CONF[\"sql_password\"]  = \"$sql_password\";\n\n";
	$str .= "\$_CONF[\"path\"]          = \"$path\";\n";
	$str .= "\$_CONF[\"path_html\"]     = \"$path_html\";\n";
	$str .= "\$_CONF[\"site_url\"]      = \"$site_url\";\n";
	$str .= "\$_CONF[\"site_email\"]    = \"$site_email\";\n\n";
	$str .= "?" . ">";
		
	fputs($fp, $str);
	fclose($fp);

		// This will initialize the global _CONF variable
		
	include($confPath);
	
	$_CONF["path_preferences"]          = $_CONF["path"] . "/preferences/";
	$_CONF["path_logs"]                 = $_CONF["path"] . "/logs/";
	$_CONF["path_users"]                = $_CONF["path"] . "/users/";
	$_CONF["path_groups"]               = $_CONF["path"] . "/groups/";
}

?>