<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   
   
require_once "install_functions.php";


/* Function:			Connect_Database
 *
 * Description:			Function for connecting to the database
 *
 * Parameters:			none
 *
 * Revision History:	3/12/2003 - adam
 *
 */

function Connect_Database()
{
	global $_CONF;
	
		// Try to connect to the database
	
	@mysql_connect(	$_CONF["sql_host"],
					$_CONF["sql_user"],
					$_CONF["sql_password"]) || die("<p>Can't Connect to Database.</p><p>Please verify that your settings are correct.</p>");
		
		
	$database = mysql_select_db($_CONF["sql_database"]);
	
	if(!$database) die("<p>Can't connect to database: <b>" . $_CONF["sql_database"] . "</b></p><p>" . mysql_error() . "</p>");	
	
	return true;
}



/* Function:			Install_Database
 *
 * Description:			Function for installing the default database
 *
 * Parameters:			none
 *
 * Revision History:	3/12/2003 - adam
 *
 */

function Install_Database()
{
	global $_CONF;
	
	$response = "";
	$dropTables = $_REQUEST["drop"];
	
	
	/* Table:				soybo_access_client
	 *
	 * Description:			table contain access rules for a particular device (user agent)
	 *
	 *	id                	- the unique ID for the entry
	 *	type				- Specifies whether the user_group_id column should be interpreted as a user_id (1) or a group_id (2)
	 *	user_group_id		- the user or group id, depending on value of id_type
	 *	access				- 1 = ban, 2 = allow
	 *	useragent			- the HTTP User Agent for the access rule
	 *
	 * Revision History:	3/12/2003 - adam
	 *
	 */
	
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_access_client";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_access_client\" in the database.", $query, mysql_error());
	}
	
	$query = "CREATE TABLE soybo_access_client (
	  id int(10) unsigned NOT NULL auto_increment,
	  type tinyint(1) NOT NULL default '0',
	  user_group_id int(10) unsigned NOT NULL default '0',
	  access tinyint(4) NOT NULL default '0',
	  useragent varchar(255) NOT NULL default '',
	  PRIMARY KEY  (id),
	  KEY useragent (useragent),
	  KEY type (type),
	  KEY user_group_id (user_group_id)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_access_client\" in the database.", $query, mysql_error());
	
	$response .= "<p style=\"margin-left: 15px;\">";
	
	$response .= "Soybo Access Rules Clients Table: OK<br />";
	
	
	/* Table:				soybo_access_ip
	 *
	 * Description:			table contain access rules for a particular IP Address
	 *
	 *	id				- the unique ID for the entry
	 *	ip_address		- the IP Address for the access rule
	 *	type			- Specifies whether the user_group_id column should be interpreted as a user_id (1) or a group_id (2)
	 *	user_group_id	- the user or group id, depending on value of id_type
	 *	access			- 1 = ban, 2 = allow
	 *
	 * Revision History:	3/12/2003 - adam
	 *
	 */
	 
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_access_ip";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_access_ip\" in the database.", $query, mysql_error());
	}	
		
	$query = "CREATE TABLE soybo_access_ip (
	  id int(10) unsigned NOT NULL auto_increment,
	  ip_address varchar(16) NOT NULL default '',
	  type tinyint(4) NOT NULL default '0',
	  user_group_id int(10) unsigned NOT NULL default '0',
	  access tinyint(4) NOT NULL default '0',
	  PRIMARY KEY  (id),
	  KEY type (type),
	  KEY user_group_id (user_group_id)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_access_ip\" in the database.", $query, mysql_error());
	
	
	$response .= "Soybo Access Rules IP Addresses Table: OK<br />";
	
		
	/* Table:		soybo_clients
	 *
	 * Description:	table containing a list of all http user-agents that have accessed the server, along
	 *				with the client class to use for display purposes for that user agent.
	 *
	 *	id			- the unique ID for the entry
	 *	useragent	- the HTTP User Agent string for the device
	 *	clientname	- the name of the Soybo Client class to use with this particular useragent
	 *
	 * Revision History:	3/12/2003 - adam
	 *
	 */
	 
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_clients";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_clients\" in the database.", $query, mysql_error());
	}
	
	$query = "CREATE TABLE soybo_clients (
	  client_id int(10) NOT NULL auto_increment,
	  useragent varchar(255) NOT NULL default '',
	  clientname varchar(33) NOT NULL default '',
	  PRIMARY KEY  (client_id),
	  UNIQUE KEY useragent (useragent),
	  KEY useragent_2 (useragent)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_clients\" in the database.", $query, mysql_error());
	
	$response .= "Soybo Clients Table: OK<br />";
	
	$useragent = $_SERVER["HTTP_USER_AGENT"];
	$query =   "INSERT INTO soybo_clients (useragent, clientname)  VALUES ('$useragent', 'Desktop_Client')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_clients\" in the database.", $query, mysql_error());

	$response .= "Soybo Clients Default Data: OK<br />";


	/* Table:		soybo_directories
	 *
	 * Description:	directories table for users and groups
	 *
	 *	dir_id - the unique ID for the entry
	 *	dir_parent - the id for the directory to which this entry belongs. Specify 0 for the home directory
	 *	type - specify whether the value for the user_group_id slot is a group id or a user id
	 *	user_group_id - the user or group id
	 *	icon - the filename for the directories icon
	 *	dirname - the name of the directory
	 *	description - the description of the directory
	 *
	 * Revision History:	3/12/2003 - adam
	 *
	 */
	 

	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_directories";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_directories\" in the database.", $query, mysql_error());
	}

	$query = "CREATE TABLE soybo_directories (
	  dir_id int(10) unsigned NOT NULL auto_increment,
	  dir_parent int(10) unsigned NOT NULL default '0',
	  type tinyint(3) unsigned NOT NULL default '0',
	  user_group_id int(10) unsigned NOT NULL default '0',
	  icon varchar(33) NOT NULL default '',
	  dirname varchar(33) NOT NULL default '',
	  description varchar(255) NOT NULL default '',
	  PRIMARY KEY  (dir_id),
	  KEY dir_parent (dir_parent,type,user_group_id)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_directories\" in the database.", $query, mysql_error());
	
	$response .= "Soybo Directories Table: OK<br />";
	
	
		// The Administrator folders: Admin and My Account
	
	$query =   "INSERT INTO soybo_directories (dir_id, dir_parent, type, user_group_id, icon, dirname, description)  VALUES ('1', '0', '2', '1', 'admin.gif', 'Admin', 'Administer your Soybo Server')";
	$result = mysql_query($query) or mysql_err("Can't create default dataset for \"soybo_directories\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_directories (dir_id, dir_parent, type, user_group_id, icon, dirname, description)  VALUES ('2', '0', '2', '1', 'account.gif', 'My Account', 'Manage your Soybo account')";
	$result = mysql_query($query) or mysql_err("Can't create default dataset for \"soybo_directories\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_directories (dir_id, dir_parent, type, user_group_id, icon, dirname, description)  VALUES ('3', '0', '2', '3', 'account.gif', 'My Account', 'Manage your Soybo account')";			
	$result = mysql_query($query) or mysql_err("Can't create default dataset for \"soybo_directories\" in the database.", $query, mysql_error());

	$response .= "Soybo Directories Default Data: OK<br />";
	
	
	
	/* Table:				soybo_groups
	 *
	 * Description:			table containing information about Soybo Groups
	 *
	 *	group_id	- the unique ID of the group
	 *	groupname	- unique string for the group
	 *
	 * Revision History:	3/12/2003 - adam
	 *
	 */
	 
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_groups";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_groups\" in the database.", $query, mysql_error());
	}
	
	$query = "CREATE TABLE soybo_groups (
	  group_id int(10) unsigned NOT NULL auto_increment,
	  groupname varchar(33) NOT NULL default '',
	  PRIMARY KEY  (group_id),
	  UNIQUE KEY groupname (groupname)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_groups\" in the database.", $query, mysql_error());
	
	
	$response .= "Soybo Groups Table: OK<br />";
	
	
	/*
	 * Create the default groups, Administrator, Guest, and Member
	 *
	 */
	
	$query = "INSERT INTO soybo_groups (group_id, groupname) VALUES (1, 'Administrator')";
	$result = mysql_query($query) or mysql_err("Can't create the Administrator group in \"soybo_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_groups (group_id, groupname) VALUES (2, 'Guest')";
	$result = mysql_query($query) or mysql_err("Can't create theGuest group in \"soybo_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_groups (group_id, groupname) VALUES (3, 'Member')";
	$result = mysql_query($query) or mysql_err("Can't create theMember group in \"soybo_groups\" in the database.", $query, mysql_error());
	
		
	$response .= "Soybo Default Groups (Administrator, Guest, Member): OK<br />";
	
	
	/* Table:				soybo_logs_server
	 *
	 * Description:			table containing logged information about the use of the server
	 *
	 *	id			- the unique ID for the log entry
	 *	time		- the time when the entry was logged
	 * 	type		- enumerated list corresponding to the type of entry being added (i.e. Admin, Server, Error, Session)
	 *	user_id		- the ID of the user that triggered the log event
	 *	session_id	- the session_id associated with the log event
	 *	description	- string describing the logged event
	 *
	 * Revision History:	3/12/2003 - adam
	 *
	 */
	 
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_logs_server";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_logs_server\" in the database.", $query, mysql_error());
	}
	
	$query = "CREATE TABLE soybo_logs_server (
	  id int(10) unsigned NOT NULL auto_increment,
	  time timestamp(14) NOT NULL,
	  type tinyint(3) unsigned NOT NULL default '0',
	  user_id int(10) NOT NULL default '0',
	  session_id varchar(33) NOT NULL default '',
	  description varchar(255) NOT NULL default '',
	  PRIMARY KEY  (id),
	  KEY type (type),
	  KEY user_id (user_id)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_logs_server\" in the database.", $query, mysql_error());
	
	
	$response .= "Soybo Server Logs Table: OK<br />";
	
	
		
	/* Table:				soybo_logs_sessions
	 *
	 * Description:			table containing a list of every session that's ever existed on the server
	 *
	 *	id			- the unique ID of the log entry
	 *	time		- the time the session was created
	 *	session_id	- the session id
	 *	user_id		- the user ID associated with the session
	 *	ip_address	- the IP Address associated with the session
	 *	useragent	- the user-agent of the device associated with the session
	 *
	 * Revision History:	3/12/2003 - adam
	 *
	 */
	 
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_logs_sessions";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_logs_sessions\" in the database.", $query, mysql_error());
	}
	
	$query = "CREATE TABLE soybo_logs_sessions (
	  id int(10) unsigned NOT NULL auto_increment,
	  time timestamp(14) NOT NULL,
	  session_id varchar(16) NOT NULL default '',
	  user_id int(10) NOT NULL default '0',
	  ip_address varchar(16) NOT NULL default '',
	  useragent varchar(255) NOT NULL default '',
	  PRIMARY KEY  (id),
	  KEY user_id (user_id),
	  KEY ip_address (ip_address),
	  KEY useragent (useragent)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_logs_sessions\" in the database.", $query, mysql_error());
	
	
	$response .= "Soybo Session Logs Table: OK<br />";
	
	
		
	/* Table:				soybo_preferences
	 *
	 * Description:			Soybo Server preferences are stored in this table.
	 *
	 * Columns:	
	 *
	 *	id							- the unique id of the preferences
	 *	version						- the version of the Soybo server prefs
	 *	default_locale_name			- the name of the default language to be used with new sessions
	 *	default_client_classname	- the name of the default client to display for new sessions
	 *	session_expires_after		- the time after which a session should be expired
	 *	session_cleanup_delay		- the time after which the server should clean up the soybo_sessions table
	 *	session_cleanup_time		- the time at which the last session cleanup occurred
	 *	allow_logging				- flag to log events by the server, user, admin, and errors
	 *	allow_guest_access			- flag to allow guests to use the server
	 *	allow_http_access			- flag to allow HTTP access to the server
	 *	allow_xmlrpc_access			- flag to allow XML-RPC requests (other than loopback requests) to the server
	 *	allow_loopback_calls		- flag to allow requests coming from localhost (127.0.0.1) with the user's session_id
	 *
	 * Revision History:	3/12/2003 - adam
	 *
	 */
	 
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_preferences";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_preferences\" in the database.", $query, mysql_error());
	}

	$query = "CREATE TABLE soybo_preferences (
	  id tinyint(3) unsigned NOT NULL default '1',
	  version varchar(12) NOT NULL default '',
	  default_locale_name varchar(33) NOT NULL default '',
	  default_client_classname varchar(33) NOT NULL default '',
	  session_expires_after int(10) unsigned NOT NULL default '3600',
	  session_cleanup_delay int(10) unsigned NOT NULL default '1800',
	  session_cleanup_time timestamp(14) NOT NULL,
	  allow_logging tinyint(1) unsigned NOT NULL default '1',
	  allow_guest_access tinyint(1) NOT NULL default '0',
	  allow_http_access tinyint(1) NOT NULL default '1',
	  allow_xmlrpc_access tinyint(1) NOT NULL default '1',
	  allow_loopback_calls tinyint(1) NOT NULL default '1',
	  PRIMARY KEY  (id)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_preferences\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_preferences VALUES (1, '1.0.0', 'english', 'Desktop_Client', 3600, 1800, 0, 1, 0, 1, 1, 1)";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_preferences\" in the database.", $query, mysql_error());
	
	
	$response .= "Soybo Preferences Table: OK<br />";
	


	/* Table:			soybo_services
	 *
	 * Description:		Table containing installed services for this Soybo Server
	 *
	 * Columns:
	 *
	 *	service_id - unique id for the entry
	 *	service_name - unique name for the service
	 *	version - version of the service
	 *	name - the name of the service
	 *	description - the description of the service
	 *	default_locale - the default localization file to use (optional)
	 *	script - the name of the service's entry point script
	 *	wap_compatible - specifies whether this service handle WAP devices
	 *	icon - the filename of the service's icon
	 *	author - the author of this service
	 *	authorEmail - the email address for the author
	 *	website - the web site url for the author
	 *	path - the path to the service. this will be the folder name
	 *
	 * Revision History:	3/21/2003 - adam
	 *
	 */
	 
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_services";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_services\" in the database.", $query, mysql_error());
	}

	$query = "CREATE TABLE soybo_services (
	  service_id int(10) unsigned NOT NULL auto_increment,
	  service_name varchar(33) NOT NULL default '',
	  version varchar(12) NOT NULL default '',
	  name varchar(33) NOT NULL default '',
	  description varchar(255) NOT NULL default '',
	  default_locale varchar(33) NOT NULL default '',
	  script varchar(33) NOT NULL default '',
	  wap_compatible tinyint(1) unsigned NOT NULL default '0',
	  icon varchar(33) NOT NULL default '',
	  author varchar(100) NOT NULL default '',
	  email varchar(100) NOT NULL default '',
	  website varchar(100) NOT NULL default '',
	  path varchar(255) NOT NULL default '',
	  PRIMARY KEY  (service_id),
	  KEY service_name (service_name)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_services\" in the database.", $query, mysql_error());

	$query = "INSERT INTO soybo_services VALUES (1, 'access-ip_soybo', '1.0.0', 'Access Control', 'Manage access to your Soybo Server', 'english', 'access.php', 0, 'icon.gif', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'Access Control')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services VALUES (2, 'clients_soybo', '1.0.0', 'Clients', 'Manage devices access your Soybo Server', 'english', 'clients.php', 0, 'icon.gif', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'Clients')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services VALUES (3, 'mediacache_soybo', '1.0.0', 'Clear Media Cache', 'Clear the media cache on your Soybo Server.', 'english', 'clearmedia.php', 0, 'icon.gif', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'Clear Media Cache')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services VALUES (4, 'preferences_soybo', '1.0.0', 'Server Preferences', 'Adjust your Soybo Server preferences.', 'english', 'preferences.php', 0, 'icon.gif', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'Server Preferences')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services VALUES (5, 'services_soybo', '1.0.0', 'Services Management', 'Manage your Soybo Services', 'english', 'services_management.php', 0, 'icon.gif', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'Services Management')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services VALUES (6, 'sessions_soybo', '1.0.0', 'Session Management', 'Manage sessions on your Soybo Server', 'english', 'session_management.php', 0, 'icon.gif', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'Session Management')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services VALUES (7, 'smarty_soybo', '1.0.0', 'Smarty', 'Smarty Template Engine', 'english', 'smarty.php', 0, 'icon.gif', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'Smarty')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services VALUES (8, 'users-groups_soybo', '1.0.0', 'User and Groups', 'Manage Users and Groups on your Soybo Server.', 'english', 'users_and_groups.php', 0, 'icon.gif', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'User and Groups')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services VALUES (9, 'user-clients_soybo', '1.0.0', 'My Clients', 'Manage your devices accessing this Soybo Server', 'english', 'myclients.php', 0, 'icon.gif', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'User Clients')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services VALUES (10, 'user-email_soybo', '1.0.0', 'Update Email', 'Update your email address', 'english', 'update_email.php', 0, '', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'Update Email')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services VALUES (11, 'userpassword_soybo', '1.0.0', 'Change Password', 'Change your password', 'english', 'changepassword.php', 0, '', 'Adam Tow', 'dts@soybo.com', 'http://www.soybo.com', 'Change Password')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services\" in the database.", $query, mysql_error());
	
	$response .= "Soybo Services Default Data: OK<br />";
	
	

	/* Table:		soybo_services_users_groups
	 *
	 * Description:	Table containing the services belonging to users and groups
	 *
	 * Columns:
	 *
	 *	id - the unique id for the entry
	 *	type - 1 for user, 2 for group
	 *	user_group_id - the user or group id
	 *	dir_id - the directory id to which the service belongs
	 *	service_name - unique name for the service
	 *
	 * Revision History:	3/21/2003 - adam
	 *
	 */
	 
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_services_users_groups";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_services\" in the database.", $query, mysql_error());
	}
	
	$query = "CREATE TABLE soybo_services_users_groups (
	  id int(10) unsigned NOT NULL auto_increment,
	  type tinyint(3) NOT NULL default '0',
	  user_group_id int(10) unsigned NOT NULL default '0',
	  dir_id int(10) unsigned NOT NULL default '0',
	  service_name varchar(33) NOT NULL default '',
	  PRIMARY KEY  (id),
	  KEY type (type,user_group_id,dir_id,service_name)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
		// Add default services for the Administrator and Member groups

	$query = "INSERT INTO soybo_services_users_groups VALUES (1, 2, 1, 1, 'access-ip_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (2, 2, 1, 1, 'clients_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (3, 2, 1, 1, 'mediacache_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (4, 2, 1, 1, 'preferences_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (5, 2, 1, 1, 'services_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (6, 2, 1, 1, 'sessions_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (7, 2, 1, 1, 'smarty_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (8, 2, 1, 1, 'users-groups_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (9, 2, 1, 2, 'user-clients_soybo')";				
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (10, 2, 1, 2, 'user-email_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (11, 2, 1, 2, 'userpassword_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (12, 2, 3, 3, 'user-clients_soybo')";				
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (13, 2, 3, 3, 'user-email_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
	
	$query = "INSERT INTO soybo_services_users_groups VALUES (14, 2, 3, 3, 'userpassword_soybo')";
	$result = mysql_query($query) or mysql_err("Can't create default data for \"soybo_services_users_groups\" in the database.", $query, mysql_error());
    
	$response .= "Soybo Services for Administrator and Members Groups: OK<br />";
	
	

	/* Table:				soybo_sessions
	 *
	 * Description:			Table containing active sessions for this Soybo Server.
	 *
	 * Columns:
	 *
	 *	session_id		- this is stored on the client-side cookie
	 *	ip_address		- the IP Address associated with the session
	 *	user_id			- the User ID associated with the session
	 *	session_start	- time when the session started
	 *	session_end		- time when the session will expire
	 *	useragent		- the user-agent of the device associated with the session
	 *
	 *
	 * Revision History:	3/13/2003 - adam
	 *
	 */
	
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_sessions";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_sessions\" in the database.", $query, mysql_error());
	}
	
	$query = "CREATE TABLE soybo_sessions (
	  session_id varchar(33) NOT NULL default '',
	  ip_address varchar(16) NOT NULL default '',
	  user_id int(10) NOT NULL default '0',
	  session_start timestamp(14) NOT NULL,
	  session_end timestamp(14) NOT NULL,
	  useragent varchar(255) NOT NULL default '',
	  PRIMARY KEY  (session_id),
	  KEY user_id (user_id)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_sessions\" in the database.", $query, mysql_error());
	
	
	$response .= "Soybo Sessions Table: OK<br />";
	
	
	/* Table:				soybo_users
	 *
	 * Description:			Table containing users of this Soybo server
	 *
	 *	user_id			- the unique ID for the user
	 *	group_id		- the ID of the user's group
	 *	username		- the username of the user for logging into the server
	 *	password		- the MD5 hash of the password for the user
	 *	firstname		- the first name of the user (optional)
	 *	lastname		- the last name of the user (optional)
	 *	email			- the email address of the user
	 *
	 * Revision History:	3/13/2003 - adam
	 *
	 */
	
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_users";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_users\" in the database.", $query, mysql_error());
	}
	
	$query = "CREATE TABLE soybo_users (
	  user_id int(10) unsigned NOT NULL auto_increment,
	  group_id int(10) unsigned NOT NULL default '2',
	  username varchar(33) NOT NULL default '',
	  password varchar(33) NOT NULL default '',
	  firstname varchar(33) NOT NULL default '',
	  lastname varchar(33) NOT NULL default '',
	  email varchar(60) NOT NULL default '',
	  PRIMARY KEY  (user_id),
	  KEY username (username),
	  KEY group_id (group_id)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_users\" in the database.", $query, mysql_error());
	
	
	$response .= "Soybo Users Table: OK<br />";
	
	
	/*
	 * Create the default guest user account
	 *
	 */
	
	$query = "INSERT INTO soybo_users (user_id, group_id, username)  VALUES (1, 2, 'guest')";
	$result = mysql_query($query) or mysql_err("Can't create default dataset for \"soybo_users\" in the database.", $query, mysql_error());

	$response .= "Soybo Guest Account: OK<br />";
	
	
	
	/* Table:				soybo_users_clients
	 *
	 * Description: 		Table for storing the user's client preferences. These override the default client preferences
	 *						stored in the soybo_clients database table.
	 *
	 * Columns:				id - the unique id for the entry
	 *						user_id	- the User ID associated with this workspace
	 *						clientname - the client classname to use
	 *						useragent - the http user agent attached to the particular client
	 *
	 * Revision History:	3/17/2003 - adam
	 *
	 */
	
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_users_clients";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_users\" in the database.", $query, mysql_error());
	}


	$query = "CREATE TABLE soybo_users_clients (
	  id int(10) unsigned NOT NULL auto_increment,
	  user_id int(10) NOT NULL default '0',
	  clientname varchar(33) NOT NULL default '',
	  useragent varchar(255) NOT NULL default '',
	  PRIMARY KEY  (id),
	  KEY user_id (user_id)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_users_clients\" in the database.", $query, mysql_error());
	
	
	$response .= "Soybo Users Clients Table: OK<br />";
	
	
	
	/* Table:				soybo_workspaces
	 *
	 * Description: 		Table for storing the user's current workspace, which includes a cached
	 *						copy of the user's home object, localization strings, and more.
	 *
	 * Columns:				id - the unique id for the entry
	 *                      user_id		- the User ID associated with this workspace
	 *						workspace	- serialized string containing information about the user's current state
	 *
	 * Revision History:	3/12/2003 - adam
	 *
	 */
	
	if($dropTables) {
		$query = "DROP TABLE IF EXISTS soybo_workspaces";
		$result = mysql_query($query) or mysql_err("Can't drop table \"soybo_workspaces\" in the database.", $query, mysql_error());
	}
	
	$query = "CREATE TABLE soybo_workspaces (
	  id int(10) unsigned NOT NULL auto_increment,
	  user_id int(10) unsigned NOT NULL default '0',
	  workspace longblob NOT NULL,
	  PRIMARY KEY  (id),
	  KEY user_id (user_id)
	)";
	$result = mysql_query($query) or mysql_err("Can't create table \"soybo_workspaces\" in the database.", $query, mysql_error());

	$response .= "Soybo Workspaces Table: OK</p>";
	
	return $response;
}



?>