<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   
   
/* Class:       Authenticator
 *
 * Description: Authenticators take information from the authenticationInfo array
 *              and determine whether or not the user entered the correct
 *              authentication information.
 *
 * Revision History: 2003-03-15 - adam
 *
 */

$_AUTHENTICATORS = array();

class Authenticator
{
    var $name;
    
    function Authenticator()
    {
        $this->name = "Authenticator";
    }

    /* Authenticate
     *
     * Takes the information in the $loginInfo variable and analyzes
     * it with the user information in the database. Returns true
     * if the user has been authenticate or false if not.
     *
     * This function is overriden by the authentication classes that
     * extend on this class.
     *
     */
     
    function Authenticate($loginInfo)
    {       
        return false;
    }

}



/* Function:    GFn_Load_Authenticators
 *
 * Description: Opens the authenticators directory and loads up
 *              any different authenticator class files.
 *
 * Parameters:  None
 *
 * Returns:     true
 *
 * Revision History: 2003-03-15 - adam
 *
 *
 */
 
function GFn_Load_Authenticators()
{
    global $_CONF;
    global $_AUTHENTICATORS;
    
        // Include every .php file in the /support/authenticators/ directory
    
    $pathToAuthenticators = $_CONF["path_html"] . "/support/authenticators/";
    
    $d = dir($pathToAuthenticators);
    while(false !== ($file = $d->read())) {
    
        $pathInfo = pathinfo($file);
    
            // Load only php files
            
        if($pathInfo["extension"] == "php") {       
            $filePath = $pathToAuthenticators . $file;
            include($filePath);
        }
    }
    $d->close();
    
    return true;
}
    
?>