<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

class database
{   
    var $db;
    
    function database()
    {
        $this->connect_db();
    }


    /* Method:      connect_db
     *
     * Description: Connects to the database.
     *
     * Parameters:  None
     *
     * Returns:     true or error
     *
     * Revision History:
     *
     *  2003-03-17 - Initial version (adam)
     *
     */
     
    function connect_db()
    {   
        global $_CONF;
        
        mysql_connect(  $_CONF["sql_host"],
                        $_CONF["sql_user"],
                        $_CONF["sql_password"]) || die("Can't Connect to Database: " . mysql_error());
        
        
        $this->db = mysql_select_db($_CONF["sql_database"]);
        
        return true;
    }



    /* Method:      Query
     *
     * Description: Queries the database and returns the result
     *
     * Parameters:  query - the query string
     *              
     * Returns:     query result or error
     *
     * Revision History:
     *
     *  2003-03-22 - Initial version (adam)
     *
     *
     */
     
     function Query($query)
     {
        $result = mysql_query($query);
        
        if($result) 
            return $result;
         else {
            die(mysql_error());
         }
     }



    /* Method:      Remove_Row
     *
     * Description: Deletes all rows in a table with a single matching $key, $value pairs
     *
     * Parameters:  tableName   - the table in which to delete data
     *              key         - the key to search on
     *              value       - the value of the key to match
     *
     * Returns:     1 on success, false otherwise
     *
     * Revision History:
     *
     *  2003-03-17 - Initial version (adam)
     *
     */
    
    function Remove_Row($tableName, $key, $value)
    {
        $result = $this->Query("DELETE FROM $tableName WHERE $key='$value'");

        return $result;
    }
    
    
    
    /* Get_Row
     *
     * Retrieves the requested row from the requested table
     *
     * Parameters:  tableName   - the table in which to delete data
     *              field       - the field you want retrieved
     *              key         - the key to search on
     *              value       - the value of the key to match
     *
     * Returns:     the value of the field or false if no match was found.
     *
     * Revision History:
     *
     *  2003-03-17 - Initial version (adam)
     *
     *
     */
    
    function Get_Row($tableName, $field, $key, $keyValue)
    {
        $result = $this->Query("SELECT $field FROM $tableName WHERE $key='$keyValue'");
        $row = mysql_fetch_assoc($result);
        
        return $row;
    }
    
    
    /* Method:      Update_Row
     *
     * Description: Updates a row in a table
     *
     * Parameters:  tableName   - the table in which to delete data
     *              field       - the field you want retrieved
     *              key         - the key to search on
     *              value       - the value of the key to match
     *
     * Returns:     the value of the field or false if no match was found.
     *
     * Revision History:
     *
     *  2003-03-17 - Initial version (adam)
     *
     *
     */
    
    function Update_Row($tableName, $field, $fieldValue, $key, $keyValue)
    {
        $result = $this->Query("UPDATE $tableName SET $field='$fieldValue' WHERE $key='$keyValue'");
        
        return $result;
    }
    
    
    
    /* Method:      Get_User_ID
     *
     * Description: Given a username, retrieves the user id
     *
     * Parameters:  username - the username to search for
     *
     * Returns:     The user's id or false if no user was found
     *
     * Revision History:
     *
     *  2003-03-17 - Initial version (adam)
     *
     */
    
    function Get_User_ID($username)
    {
        $result = $this->Query("SELECT user_id FROM soybo_users WHERE username='$username'");
        $row = mysql_fetch_assoc($result);
            
        return ($row) ? $row["user_id"] : false;
    }



    /* Method:      Get_Username
     *
     * Description: Given a user id, retrieves the user's username
     *
     * Parameters:  user_id - the user id to search for
     *
     * Returns:     The username or false if no user was found
     *
     * Revision History:
     *
     *  2003-03-17 - Initial version (adam)
     *
     */
    
    function Get_Username($user_id)
    {       
       $result = $this->Query("SELECT username FROM soybo_users WHERE user_id='$user_id'");
       $row = mysql_fetch_assoc($result);
       
       return ($row) ? $row["username"] : false;
    }
    
    
    
    /* Method:      Get_Username_From_Session
     *
     * Description: Given a session id, we retrieve the username of the user attached to the session
     *
     * Parameters:  session_id - the session id to search for
     *
     * Returns:     The username or false if no user was found
     *
     * Revision History:
     *
     *  2003-03-17 - Initial version (adam)
     *
     */
    
    function Get_Username_From_Session($session_id)
    {
        $row = $this->Get_Row("soybo_sessions", "user_id", "session_id", $session_id);

        if($row) {
            $uid = $row["user_id"];
            $username = $this->Get_Username($uid);

            return $username;
        }
        
        return false;
    }
    
    
    
    /* Method:      Get_Group_ID_From_User_ID
     *
     * Description: Given a user_id, find the user's group id
     *
     * Parameters:  user_id - the user id to search for
     *
     * Returns:     The group id or false if no user was found
     *
     * Revision History:
     *
     *  2003-03-17 - Initial version (adam)
     *
     */
    
    function Get_Group_ID_From_User_ID($user_id)
    {       
        $result = $this->Query("SELECT group_id FROM soybo_users WHERE user_id='$user_id'");
        $row = mysql_fetch_assoc($result);
        
        return ($row) ? $row["group_id"] : false;
    }
    
    
    
    /* Method:      Get_Groupname
     *
     * Description: Given a group id, get the group's name
     *
     * Parameters:  group_id - the group id to search for
     *
     * Returns:     The groupname or false if no group was found
     *
     * Revision History:
     *
     *  2003-03-17 - Initial version (adam)
     *
     */
    
    function Get_Groupname($group_id)
    {       
        $result = $this->Query("SELECT groupname FROM soybo_groups WHERE group_id='$group_id'");

        $row = mysql_fetch_assoc($result);
        
        return ($row) ? $row["groupname"] : false;
    }
    
    
    /* Function:    Get_Dirname
     * 
     * Description: Retrieves the name of a directory from the database, given a directory id.
     *
     * Parameters:  dir_id - the directory id to search for
     *
     * Returns:     Directory name or false
     *
     * Revision History:
     *
     *  2003-03-21 - Initial version (adam)
     *
     *
     */
     
    function Get_Dirname($dir_id)
    {
        global $_CONF;
        
        if($dir_id == 0) {
            return $_CONF["locale"]->GetString("labelHome");
        } else {
            $result = $this->Query("SELECT dirname FROM soybo_directories WHERE dir_id='$dir_id'");
            $row = mysql_fetch_row($result);
            $dirname = $row[0];
    
            return $dirname;
        }
    }
    
    
    
    /* Function:    Get_User
     * 
     * Description: Retrieves the user from the database, given the username
     *
     * Parameters:  username - the unique name for the user
     *
     * Returns:     User or false if no user was found
     *
     * Revision History:
     *
     *  2003-03-22 - Initial version (adam)
     *
     *
     */
     
    function Get_User($username)
    {
        $result = $this->Query("SELECT * FROM soybo_users WHERE username='$username'");
        $user = mysql_fetch_assoc($result);
        
        return $user;
    }


    /* Function:    Get_Service
     * 
     * Description: Retrieves the service from the database, given the service name
     *
     * Parameters:  service_name - the unique name for the service
     *
     * Returns:     Service or false if no service was found
     *
     * Revision History:
     *
     *  2003-03-22 - Initial version (adam)
     *
     *
     */
     
    function Get_Service($service_name)
    {
        $result = $this->Query("SELECT * FROM soybo_services WHERE service_name='$service_name'");
        $service = mysql_fetch_assoc($result);
        
        return $service;
    }
    
    
    
   
}


?>