<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   
   
class Script_Handler
{
    var $name;
    
    function Script_Handler()
    {
        $this->name = "Generic Script Handler";
    }

    /* Method:      Execute
     *
     * Description: Runs the script with the listed methodName and parameters.
     *
     * Parameters:  scriptPath - the path to the script
     *              methodName - the method to call in the script
     *              paramters - parameters to send to the script
     *
     * Returns:     the result of the script
     *
     * Revision History:
     *
     *  2003-03-15 - Initial version (adam)
     *
     */
     
    function RunScript($scriptPath, $methodName, $parameters)
    {
        return false;
    }

}


    // Open the Scripts directory and load up the different 
    // Script classes.

$scripts = array();


/* Function:    GFn_LoadScripts()
 * 
 * Description: Scans the given path and loads any script handlers in the directory
 *
 * Parameters:  None
 *
 * Return:      true
 *
 * Revision History: 2003-03-15 - adam
 *
 */

function GFn_LoadScripts($pathToScripts)
{
    global $_CONF;
            
    $pathToScriptHandlers = $_CONF["path_html"] . $pathToScripts;

    $d = dir($pathToScriptHandlers);
    
    while(false !== ($file = $d->read())) {
        $pathInfo = pathinfo($file);
        
        if($pathInfo["extension"] == "php") {       
            $filePath = $pathToScriptHandlers . $file;

            include_once($filePath);
        }
    }
    $d->close();
}



?>