<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

    // Load this authenticator into the authenticators array

global $_AUTHENTICATORS;

$_AUTHENTICATORS["Basic"] = "Basic_Authenticator";



/* Class:       Basic_Authenticator
 *
 * Description: This authentication class handles the typical username/password
 *              type of authentication.
 *
 * Revision History:
 *
 *  2003-03-15 - Initial version (adam)
 *
 */
  
class Basic_Authenticator extends Authenticator
{
    function Basic_Authenticator()
    {
        $this->name = "Basic Authenticator";    
        
    }

    /* Method:      Authenticate
     *
     * Description: Compares the username and password with that in the
     *              database. Usernames are stored in clear text, but passwords are
     *              stored as MD5 hashes. We also verify that the request's IP
     *              addresses matches the set of valid IP Addresses in the user's
     *              profile (if specified).
     *
     * Parameters:  authenticationRequest - array containing the username and password strings
     *
     * Returns:     array of true values if authenticated, error array otherwise
     *
     * Revision History:
     *
     *  2003-03-15 - Initial version (adam)
     *
     *
     */
     
    function Authenticate($authenticationRequest)
    {
        global $_CONF;
        global $_DATABASE;

        $username = $authenticationRequest["username"];
        $password = $authenticationRequest["pwd"];
                
        $result = $_DATABASE->Get_Row("soybo_users", "password", "username", $username);
        
            // Now compare an MD5 hash of the password with 
            // what's stored in the database

        if($result && md5($password) == $result["password"]) {
            return array(true, true);
        }
        
            // Passwords don't match, return and error
        
        $errTitle = $_CONF["locale"]->GetString("errLoginFailed");
        $err = $_CONF["locale"]->GetString("errLogin");
        
        return Create_Error($errTitle, $err);   
    }

}




?>