<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

global $_CLIENTS;

$_CLIENTS["Safari_Client"] = "Safari";


/* Class:       Safari_Client
 *
 * Extends:     Desktop_Client
 *
 * Description: The Safari class adds an additional stylesheet to the Desktop client class
 *              to give pages a nice, brushed metal interface.
 *
 * Revision History:
 *
 *  2003-03-15 - Initial version (adam)
 *
 */

class Safari_Client extends Desktop_Client
{
    var $safariMediaPath;
    var $safariCSSPath;
    
    function Safari_Client()
    {
        global $_CONF;
        
        $this->Desktop_Client();
        
        $this->name = "Safari";
        
        $this->mediaPath = "/skins/desktop_safari";
        $this->cssPath = $this->mediaPath . "/stylesheets/safari.css";
        $this->templatesPath = $_CONF["path_html"] . "/skins/desktop_safari/templates/";
                
        array_push($this->cssPaths, $this->cssPath);
        array_push($this->mediaPaths, $this->mediaPath);
        array_push($this->templatesPaths, $this->templatesPath);
    }
}

?>