<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   


global $_CLIENTS;

$_CLIENTS["Desktop_Client"] = "Desktop";



/* Class:       Desktop_Client
 *
 * Extends:     HTTP_Client
 *
 * Description: Desktop class for Soybo client class.
 *
 * Revision History:
 *
 *  2003-03-15 - Initial version (adam)
 *
 *
 */


class Desktop_Client extends HTTP_Client
{
    function Desktop_Client()
    {
        global $_CONF;
        
            // Call the class constructor
            
        $this->HTTP_Client();
        
        $this->name = "Desktop";
        $this->type = "Desktop";
        
        $this->mediaPath = "/skins/desktop";
        $this->cssPath = $this->mediaPath . "/stylesheets/desktop.css";
        $this->templatesPath = $_CONF["path_html"] . "/skins/desktop/templates/";
        
            // Set up the inherited paths

        array_push($this->cssPaths, $this->cssPath);        
        array_push($this->mediaPaths, $this->mediaPath);
        array_push($this->templatesPaths, $this->templatesPath);
        
    }



    /* Method:      Login_Display
     * 
     * Description: Displays the desktop login page.
     *
     * Parameters:  None
     *
     * Returns:     true
     *
     * Revision History:
     *
     *  2003-03-15 - Initial version (adam)
     *
     *
     */
    
    
    function Login_Display()
    {
            // Create the Language Popup Menu
            
        global $_LOCALIZATION;
        global $_CONF;
        
        $localeOptions = array();
        
        foreach($_LOCALIZATION as $locale => $localeArray)
            $localeOptions["$locale"] = $localeArray["display_name"];                  

        $localeName = $_CONF["localeName"];
        
        if(!$localeName)
            $localeName = $_CONF["default_locale_name"];
        
        $this->page->assign("option_options", $localeOptions);
        $this->page->assign("option_selected", $localeName);    

            // Assign the client name and the server path (in the login form)

        $this->page->assign("locale_name", $this->name);

            // Display the page
            
        $this->Template_Display("login", true);
    }
}

?>
