<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

global $_CLIENTS;

$_CLIENTS["Handheld_Client"] = "Handheld";



/* Class:       Handheld_Client
 *
 * Extends:     HTTP_Client
 *
 * Description: Handheld class for Soybo client class.
 *
 * Revision History:
 *
 *  2003-03-15 - Initial version (adam)
 *
 *
 */

class Handheld_Client extends HTTP_Client
{
    var $mediaPath;
    var $cssPath;
    var $templatesPath;
    
    function Handheld_Client()
    {
        global $_CONF;
        
            // Call the inherited class constructor
            
        $this->HTTP_Client();
        
        $this->name = "Handheld";
        $this->type = "Handheld";

        $this->mediaPath = "/skins/handheld";
        $this->cssPath = $this->mediaPath . "/stylesheets/handheld.css";
        $this->templatesPath = $_CONF["path_html"] . "/skins/handheld/templates/";
        
        array_push($this->mediaPaths, $this->mediaPath);
        array_push($this->cssPaths, $this->cssPath);
        array_push($this->templatesPaths, $this->templatesPath);
        
        
    }


    /* Method:      Login_Display
     *
     * Description: Displays a simpler login page
     *
     * Parameters:  None
     *
     * Returns:     true
     *
     * Revision History:
     *
     *  2003-03-15 - Initial version (adam)
     *
     *
     */
    
    function Login_Display()
    {
            // Create the Language Popup Menu
            
        global $_LOCALIZATION;
        global $_CONF;
        
        $localeOptions = array();
        
        foreach($_LOCALIZATION as $locale => $localeArray)
            $localeOptions["$locale"] = $localeArray["display_name"];                    

        $localeName = $_CONF["localeName"];
        
        if(!$localeName)
            $localeName = $_CONF["default_locale_name"];
        
        $this->page->assign("option_options", $localeOptions);
        $this->page->assign("option_selected", $localeName);    

            // Assign the client name and the server path (in the login form)

        $this->page->assign("locale_name", $this->name);

            // Disable the navbar and footer

        $title = $this->page->PageGet("localization", "login");
        $this->page->PageSet("title", $title);      

            // Display the page
            
        $this->Template_Display("login", true);
    }
}


?>