<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

global $_CLIENTS;

$_CLIENTS["Phone_Client"] = "Phone";


/* Class:       Phone_Client
 *
 * Extends:     HTTP_Client
 *
 * Description: Phone class for Soybo client class. Pages for phone clients
 *              should be XHTML 1.0 Basic documents.
 *
 * Revision History:
 *
 *  2003-03-15 - Initial version (adam)
 *
 *
 */

class Phone_Client extends HTTP_Client
{
    var $mediaPath;
    var $cssPath;
    var $templatesPath;
    
    function Phone_Client()
    {
        global $_CONF;
        
        $this->HTTP_Client();
        
        $this->name = "Phone";
        $this->type = "Phone";

        $this->mediaPath = "/skins/phone";
        $this->cssPath = $this->mediaPath . "/stylesheets/stylesheet.css";
        $this->templatesPath = $_CONF["path_html"] . "/skins/phone/templates/";
        
        array_push($this->mediaPaths, $this->mediaPath);
        array_push($this->cssPaths, $this->cssPath);
        array_push($this->templatesPaths, $this->templatesPath);
    }




    /* Method:      Login_Display
     * 
     * Description: Displays a simple login page.
     *
     * Parameters:  None
     *
     * Returns:     true
     *
     * Revision History:
     *
     *  2003-03-15 - Initial version (adam)
     *
     *
     */
    
    function Login_Display()
    {
            // Assign the client name and the server path (in the login form)

        $this->page->assign("name", $this->name);

            // Disable the navbar and footer

        $title = $this->page->PageGet("localization", "login");
        $this->page->PageSet("title", $title);      

            // Display the page
            
        $this->Template_Display("login", true);
    }
}

    
    
?>