<?php

/* Copyright (C) 2003 Adam Tow

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
   

class SCPT_Script_Handler extends Script_Handler
{
    var $name;
    
    function SCPT_Script_Handler()
    {
        $this->Script_Handler();
        $this->name = "AppleScript Script Handler";
    }

    /* Method:      RunScript
     *
     * Description: Runs the AppleScript
     *
     * Parameters:  scriptPath - the location of the script
     *              methodName - the method to call in the script
     *              parameters - the parameters to send to the script
     *
     * Returns:     the result of the script
     *
     * Revision History:
     *
     *  2003-03-15 - Initial version (adam)
     *
     */
     
    function RunScript($scriptPath, $methodName, $parameters)
    {

            // First we need to create a parameter list for AppleScript
        
        $paramStr = "{ ";
        $len = sizeof($parameters);
        $i = 1;
                
            // Create the parameters string
            // We also turn the locale object into an AppleScript object
        
        foreach($parameters as $p => $value) {
            if($p == "locale" && is_array($value)) {
                $paramStr .= "$p: { ";
                $len2 = sizeof($value);
                $j = 1;
                foreach($value as $name => $str) {                
                    $paramStr .= "$name: \"" . addslashes($str) . "\"";
                    if($j < $len2) $paramStr .=", ";
                    $j++;
                }
                $paramStr .= "}";
            } else {
            
                $paramStr .= "$p: \"$value\"";
            }
            
            if($i < $len)
                $paramStr .= ", ";
            $i++;
        }
        $paramStr .= " }";
        
            // Prepare the strings for sending to AppleScript
            
        $paramStr = str_replace("\\'", "'\"'\"'", $paramStr);       
        $methodName = "\"$methodName\"";
        
        $cmd = "osascript -e 'set the_script to load script file (POSIX file \"$scriptPath\" as text)' -e 'tell the_script to return RunWithParams($methodName, $paramStr)'";
        
        $pipe = @popen($cmd, "r");
        
        if($pipe) {
            while($s = fgets($pipe, 1024)) $result .= $s;
            pclose($pipe);

            return $result;
        } else {
            return "An error occurred while running this script.";
        }
    }

}


?>